<template>
  <q-list separator>
    <q-item>
      <q-input
          clearable
          dense
          class="full-width"
          v-model="newNote.title"
          borderless
          @keydown.enter="onSave"
          label="new note..."
      >
        <template #after>
          <q-btn
              v-if="newNote?.title?.length >= 3"
              @click.prevent="onSave"
              icon="save"
              dense
              flat
              round
          />
        </template>
      </q-input>
    </q-item>
    <folder-list-item
        v-for="note in notes"
        :key="note.title"
        :note="note"
        @remove="onRemove(note.title)"
        @move="onMove"
    />
  </q-list>
</template>

<script lang="ts">
import {defineComponent} from 'vue';
import '../wailsjs/go/bindings';
import {Note} from "../wailsjs/go/models";
import FolderListItem from "./FolderListItem.vue";

export default defineComponent({
  components: {
    FolderListItem
  },

  data: () => ({
    notes: ([] as Note[]),
    newNote: Note.createFrom(),
  }),

  async beforeMount() {
    this.notes = await window.go.main.App.NoteList();
    const [first] = this.notes;

    if (first) {
     await this.$router.push({name: 'Note', params: {path: first.title}})
    }
  },

  methods: {
    async onSave() {
      if (this.newNote.title.length === 0) {
        return;
      }

      const newNote = {...this.newNote};

      await Promise.all([
        window.go.main.App.StoreNote(newNote),
        this.$router.push({name: 'Note', params: {path: newNote.title}})
      ]);

      this.notes.push(newNote);
      this.newNote = Note.createFrom();
    },

    async onMove({from, to}: {from: string, to: string}) {
      const index = this.notes.findIndex(note => note.title === from);
      if (index > -1) {
        this.notes.splice(index, 1, {title: to, md: ''});
        await window.go.main.App.MoveNote(from, to)
      }
    },

    async onRemove(title: string) {
      const index = this.notes.findIndex(note => note.title === title);

      if (index > -1) {
        this.notes.splice(index, 1);
        await window.go.main.App.RemoveNote(title);
      }
    }
  }
})
</script>
